<?php
/**
 * Perforce Swarm
 *
 * @copyright   2013-2019 Perforce Software. All rights reserved.
 * @license     Please see LICENSE.txt in top-level readme folder of this distribution.
 * @version     2019.2/1886137
 */

namespace Redis\Model;

use P4\Connection\ConnectionInterface;
use Redis\RedisService;
use Workflow\Model\IWorkflow;
use Workflow\Model\Workflow;

/**
 * DAO to handle data access for the Workflow model
 * @package Redis\Model
 */
class WorkflowDAO extends AbstractDAO
{
    const CACHE_KEY_PREFIX = IWorkflow::WORKFLOW . RedisService::SEPARATOR;
    const MODEL            = Workflow::class;
    const POPULATED_STATUS = IWorkflow::WORKFLOW . "-". AbstractDAO::POPULATED_STATUS;
    // The key for the verify status of the workflow dataset
    const VERIFY_STATUS = IWorkflow::WORKFLOW  . "-" . AbstractDAO::VERIFY_STATUS;

    /**
     * @inheritDoc
     */
    public function fetchAll(array $options = [], ConnectionInterface $connection = null)
    {
        if (isset($options[Workflow::FETCH_BY_KEYWORDS])) {
            // Fall back to Perforce for key searches
            return Workflow::fetchAll($options, $connection);
        } else {
            return parent::fetchAll($options, $connection);
        }
    }
}
